using System;
using System.Collections;
using System.Text;

namespace TSP
{
	/// <summary>
	/// KLasa kromosom definira jedan kromosom, stazu i duljinu puta
	/// </summary>
	public class Kromosom : IComparable
	{
		private ArrayList _kromosom = new ArrayList();
		private double _duljinaPuta;

		public Kromosom(ArrayList jedinka, double duljina)
		{
			
			foreach(int i in jedinka)
			{
				_kromosom.Add(i);
			}
			_duljinaPuta = duljina;

		}
		/// <summary>
		/// Svojstvo koje vraa stazu
		/// </summary>
		public ArrayList Chromosome 
		{
			get 
			{
				return _kromosom;
			}
		}
		
		/// <summary>
		/// Svojstvo koje vraa ili postavlja duljinu puta kromosoma
		/// </summary>
		public double DuljinaPuta
		{
			get
			{
				return _duljinaPuta;
			}
			set
			{
				_duljinaPuta = value;
			}
		}

		public override string ToString()
		{
			StringBuilder staza = new StringBuilder();
			
			foreach(int i in _kromosom)
			{
				staza.AppendFormat("{0}, ",i);
			}

			return "staza = "+staza.ToString()+" "+"duljina = "+this._duljinaPuta.ToString();
		}
		#region IComparable Members

		public int CompareTo(object obj)
		{
			double d1 = this._duljinaPuta;
			double d2 = ((Kromosom) obj)._duljinaPuta;
			return d2.CompareTo(d1);
		}

		#endregion
	}
}
