using System;

namespace TSP
{
	/// <summary>
	/// Klasa u kojoj su definirani defaultni parametri
	/// </summary>
	

	public class Parametri
	{
		public int VelPopulacije;
		public short UvjetZaustavljanja;
		public int BrojGeneracija;
		public int NepromjenjeniNajbolji;
		public bool BrisanjeDuplikata;
		public short VrstaSelekcije;
		public short VjerojatnostKrizanja;
		public double Epsilon;
		public short VelTurnira;
		public short VrstaKrizanja;
		public short VrstaMutacije;
		public short VjerojatnostMutacije;

		public Parametri()
		{
			this.Default();
		}
		/// <summary>
		/// Konstruktor za inicijalizaciju parametara
		/// </summary>
		public Parametri(Parametri parametri)
		{
			this.VelPopulacije = parametri.VelPopulacije;
			this.UvjetZaustavljanja = parametri.UvjetZaustavljanja;
			this.BrojGeneracija = parametri.BrojGeneracija;
			this.NepromjenjeniNajbolji = parametri.NepromjenjeniNajbolji;
			this.BrisanjeDuplikata = parametri.BrisanjeDuplikata;
			this.VrstaSelekcije = parametri.VrstaSelekcije;
			this.VjerojatnostKrizanja = parametri.VjerojatnostKrizanja;
			this.Epsilon = parametri.Epsilon;
			this.VelTurnira = parametri.VelTurnira;
			this.VrstaKrizanja = parametri.VrstaKrizanja;
			this.VrstaMutacije = parametri.VrstaMutacije;
			this.VjerojatnostMutacije = parametri.VjerojatnostMutacije;
		}
		/// <summary>
		/// Defaultni parametri
		/// </summary>
		public void Default()
		{
			this.VelPopulacije = 100;
			this.UvjetZaustavljanja = 0;
			this.BrojGeneracija = 100;
			this.NepromjenjeniNajbolji = 10;
			this.BrisanjeDuplikata = false;
			this.VrstaSelekcije = 0;
			this.VjerojatnostKrizanja = 30;
			this.Epsilon = 0.00005;
			this.VelTurnira = 3;
			this.VrstaKrizanja = 0;
			this.VrstaMutacije = 2;
			this.VjerojatnostMutacije = 10;
		}
	}
}
