using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TSP
{
	/// <summary>
	/// Klasa koja postavlja parametre
	/// </summary>
	public class parametriForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl tabControl;
		private System.Windows.Forms.TabPage OsnovniParametri;
		private System.Windows.Forms.TextBox textBoxNepromjenjeni;
		private System.Windows.Forms.TextBox textBoxBrojGeneracija;
		private System.Windows.Forms.TextBox textBoxVelicinaPopulacije;
		private System.Windows.Forms.Label labelUvjetZaustavljanja;
		private System.Windows.Forms.Label labelVelicinaPopulacije;
		private System.Windows.Forms.TabPage Selekcija;
		private System.Windows.Forms.TextBox textBoxEpsilon;
		private System.Windows.Forms.Label labelTurniriSelekcija;
		private System.Windows.Forms.Label labelVelicinaTurnira;
		private System.Windows.Forms.Label labelEpsilon;
		private System.Windows.Forms.Label labelPrirodnaKrizanje;
		private System.Windows.Forms.RadioButton radioButtonTurnirskaSelekcija;
		private System.Windows.Forms.RadioButton radioButtonPrirodnaSelekcija;
		private System.Windows.Forms.TabPage Krizanje;
		private System.Windows.Forms.TabPage Mutacija;
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.Button buttonDefault;
		private System.Windows.Forms.RadioButton radioButtonPMX;
		private System.Windows.Forms.RadioButton radioButtonGSX;
		private System.Windows.Forms.RadioButton radioButtonGreedyCrossover;
		private System.Windows.Forms.RadioButton radioButtonGreedySwap;
		private System.Windows.Forms.RadioButton radioButtonJednostavna;
		private System.Windows.Forms.RadioButton radioButton2opt;
		private System.Windows.Forms.Label vjerojatnostMutacijeLabel;
		private System.Windows.Forms.NumericUpDown numericUpDownTurniri;
		private System.Windows.Forms.NumericUpDown vjerojatnostMutacijeUpDown;
		private System.Windows.Forms.NumericUpDown numericUpDownTurnirniSelekcija;
		private System.Windows.Forms.NumericUpDown numericUpDownPrirodna;
		private System.Windows.Forms.RadioButton radioButtonBrojGeneracija;
		private System.Windows.Forms.RadioButton radioButtonNepromjenjeni;
		private System.Windows.Forms.CheckBox checkBoxBrisanjeDuplikata;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		public Parametri Parametri;
		
		private System.ComponentModel.Container components = null;

		public parametriForm(Parametri parametri)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.Parametri = new Parametri(parametri);
			this.ispisiParametre();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl = new System.Windows.Forms.TabControl();
			this.OsnovniParametri = new System.Windows.Forms.TabPage();
			this.checkBoxBrisanjeDuplikata = new System.Windows.Forms.CheckBox();
			this.radioButtonNepromjenjeni = new System.Windows.Forms.RadioButton();
			this.radioButtonBrojGeneracija = new System.Windows.Forms.RadioButton();
			this.textBoxNepromjenjeni = new System.Windows.Forms.TextBox();
			this.textBoxBrojGeneracija = new System.Windows.Forms.TextBox();
			this.textBoxVelicinaPopulacije = new System.Windows.Forms.TextBox();
			this.labelUvjetZaustavljanja = new System.Windows.Forms.Label();
			this.labelVelicinaPopulacije = new System.Windows.Forms.Label();
			this.Selekcija = new System.Windows.Forms.TabPage();
			this.numericUpDownPrirodna = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownTurnirniSelekcija = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownTurniri = new System.Windows.Forms.NumericUpDown();
			this.textBoxEpsilon = new System.Windows.Forms.TextBox();
			this.labelTurniriSelekcija = new System.Windows.Forms.Label();
			this.labelVelicinaTurnira = new System.Windows.Forms.Label();
			this.labelEpsilon = new System.Windows.Forms.Label();
			this.labelPrirodnaKrizanje = new System.Windows.Forms.Label();
			this.radioButtonTurnirskaSelekcija = new System.Windows.Forms.RadioButton();
			this.radioButtonPrirodnaSelekcija = new System.Windows.Forms.RadioButton();
			this.Krizanje = new System.Windows.Forms.TabPage();
			this.radioButtonGreedyCrossover = new System.Windows.Forms.RadioButton();
			this.radioButtonGSX = new System.Windows.Forms.RadioButton();
			this.radioButtonPMX = new System.Windows.Forms.RadioButton();
			this.Mutacija = new System.Windows.Forms.TabPage();
			this.vjerojatnostMutacijeUpDown = new System.Windows.Forms.NumericUpDown();
			this.vjerojatnostMutacijeLabel = new System.Windows.Forms.Label();
			this.radioButton2opt = new System.Windows.Forms.RadioButton();
			this.radioButtonJednostavna = new System.Windows.Forms.RadioButton();
			this.radioButtonGreedySwap = new System.Windows.Forms.RadioButton();
			this.buttonOK = new System.Windows.Forms.Button();
			this.buttonDefault = new System.Windows.Forms.Button();
			this.tabControl.SuspendLayout();
			this.OsnovniParametri.SuspendLayout();
			this.Selekcija.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownPrirodna)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownTurnirniSelekcija)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownTurniri)).BeginInit();
			this.Krizanje.SuspendLayout();
			this.Mutacija.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.vjerojatnostMutacijeUpDown)).BeginInit();
			this.SuspendLayout();
			// 
			// tabControl
			// 
			this.tabControl.Controls.Add(this.OsnovniParametri);
			this.tabControl.Controls.Add(this.Selekcija);
			this.tabControl.Controls.Add(this.Krizanje);
			this.tabControl.Controls.Add(this.Mutacija);
			this.tabControl.Location = new System.Drawing.Point(16, 16);
			this.tabControl.Name = "tabControl";
			this.tabControl.SelectedIndex = 0;
			this.tabControl.Size = new System.Drawing.Size(280, 208);
			this.tabControl.TabIndex = 0;
			// 
			// OsnovniParametri
			// 
			this.OsnovniParametri.Controls.Add(this.checkBoxBrisanjeDuplikata);
			this.OsnovniParametri.Controls.Add(this.radioButtonNepromjenjeni);
			this.OsnovniParametri.Controls.Add(this.radioButtonBrojGeneracija);
			this.OsnovniParametri.Controls.Add(this.textBoxNepromjenjeni);
			this.OsnovniParametri.Controls.Add(this.textBoxBrojGeneracija);
			this.OsnovniParametri.Controls.Add(this.textBoxVelicinaPopulacije);
			this.OsnovniParametri.Controls.Add(this.labelUvjetZaustavljanja);
			this.OsnovniParametri.Controls.Add(this.labelVelicinaPopulacije);
			this.OsnovniParametri.Location = new System.Drawing.Point(4, 22);
			this.OsnovniParametri.Name = "OsnovniParametri";
			this.OsnovniParametri.Size = new System.Drawing.Size(272, 182);
			this.OsnovniParametri.TabIndex = 0;
			this.OsnovniParametri.Text = "Osnovni Parametri";
			// 
			// checkBoxBrisanjeDuplikata
			// 
			this.checkBoxBrisanjeDuplikata.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.checkBoxBrisanjeDuplikata.Enabled = false;
			this.checkBoxBrisanjeDuplikata.Location = new System.Drawing.Point(8, 152);
			this.checkBoxBrisanjeDuplikata.Name = "checkBoxBrisanjeDuplikata";
			this.checkBoxBrisanjeDuplikata.Size = new System.Drawing.Size(160, 24);
			this.checkBoxBrisanjeDuplikata.TabIndex = 13;
			this.checkBoxBrisanjeDuplikata.Text = "Brisanje Duplikata";
			// 
			// radioButtonNepromjenjeni
			// 
			this.radioButtonNepromjenjeni.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.radioButtonNepromjenjeni.Location = new System.Drawing.Point(32, 112);
			this.radioButtonNepromjenjeni.Name = "radioButtonNepromjenjeni";
			this.radioButtonNepromjenjeni.Size = new System.Drawing.Size(136, 24);
			this.radioButtonNepromjenjeni.TabIndex = 12;
			this.radioButtonNepromjenjeni.Text = "Nepromjenjeni Najbolji ";
			// 
			// radioButtonBrojGeneracija
			// 
			this.radioButtonBrojGeneracija.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.radioButtonBrojGeneracija.Checked = true;
			this.radioButtonBrojGeneracija.Location = new System.Drawing.Point(32, 80);
			this.radioButtonBrojGeneracija.Name = "radioButtonBrojGeneracija";
			this.radioButtonBrojGeneracija.Size = new System.Drawing.Size(136, 24);
			this.radioButtonBrojGeneracija.TabIndex = 11;
			this.radioButtonBrojGeneracija.TabStop = true;
			this.radioButtonBrojGeneracija.Text = "Broj Generacija";
			// 
			// textBoxNepromjenjeni
			// 
			this.textBoxNepromjenjeni.Location = new System.Drawing.Point(192, 112);
			this.textBoxNepromjenjeni.Name = "textBoxNepromjenjeni";
			this.textBoxNepromjenjeni.Size = new System.Drawing.Size(72, 20);
			this.textBoxNepromjenjeni.TabIndex = 9;
			this.textBoxNepromjenjeni.Text = "10";
			this.textBoxNepromjenjeni.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// textBoxBrojGeneracija
			// 
			this.textBoxBrojGeneracija.Location = new System.Drawing.Point(192, 80);
			this.textBoxBrojGeneracija.Name = "textBoxBrojGeneracija";
			this.textBoxBrojGeneracija.Size = new System.Drawing.Size(72, 20);
			this.textBoxBrojGeneracija.TabIndex = 8;
			this.textBoxBrojGeneracija.Text = "100";
			this.textBoxBrojGeneracija.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// textBoxVelicinaPopulacije
			// 
			this.textBoxVelicinaPopulacije.Location = new System.Drawing.Point(192, 8);
			this.textBoxVelicinaPopulacije.Name = "textBoxVelicinaPopulacije";
			this.textBoxVelicinaPopulacije.Size = new System.Drawing.Size(72, 20);
			this.textBoxVelicinaPopulacije.TabIndex = 6;
			this.textBoxVelicinaPopulacije.Text = "100";
			this.textBoxVelicinaPopulacije.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// labelUvjetZaustavljanja
			// 
			this.labelUvjetZaustavljanja.Location = new System.Drawing.Point(8, 48);
			this.labelUvjetZaustavljanja.Name = "labelUvjetZaustavljanja";
			this.labelUvjetZaustavljanja.TabIndex = 2;
			this.labelUvjetZaustavljanja.Text = "Uvjet Zaustavljanja";
			this.labelUvjetZaustavljanja.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// labelVelicinaPopulacije
			// 
			this.labelVelicinaPopulacije.Location = new System.Drawing.Point(8, 8);
			this.labelVelicinaPopulacije.Name = "labelVelicinaPopulacije";
			this.labelVelicinaPopulacije.TabIndex = 1;
			this.labelVelicinaPopulacije.Text = "Velicina Populacije";
			this.labelVelicinaPopulacije.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// Selekcija
			// 
			this.Selekcija.Controls.Add(this.numericUpDownPrirodna);
			this.Selekcija.Controls.Add(this.numericUpDownTurnirniSelekcija);
			this.Selekcija.Controls.Add(this.numericUpDownTurniri);
			this.Selekcija.Controls.Add(this.textBoxEpsilon);
			this.Selekcija.Controls.Add(this.labelTurniriSelekcija);
			this.Selekcija.Controls.Add(this.labelVelicinaTurnira);
			this.Selekcija.Controls.Add(this.labelEpsilon);
			this.Selekcija.Controls.Add(this.labelPrirodnaKrizanje);
			this.Selekcija.Controls.Add(this.radioButtonTurnirskaSelekcija);
			this.Selekcija.Controls.Add(this.radioButtonPrirodnaSelekcija);
			this.Selekcija.Location = new System.Drawing.Point(4, 22);
			this.Selekcija.Name = "Selekcija";
			this.Selekcija.Size = new System.Drawing.Size(272, 182);
			this.Selekcija.TabIndex = 1;
			this.Selekcija.Text = "Selekcija";
			// 
			// numericUpDownPrirodna
			// 
			this.numericUpDownPrirodna.Location = new System.Drawing.Point(192, 32);
			this.numericUpDownPrirodna.Name = "numericUpDownPrirodna";
			this.numericUpDownPrirodna.Size = new System.Drawing.Size(72, 20);
			this.numericUpDownPrirodna.TabIndex = 17;
			this.numericUpDownPrirodna.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.numericUpDownPrirodna.Value = new System.Decimal(new int[] {
																				30,
																				0,
																				0,
																				0});
			// 
			// numericUpDownTurnirniSelekcija
			// 
			this.numericUpDownTurnirniSelekcija.Location = new System.Drawing.Point(192, 120);
			this.numericUpDownTurnirniSelekcija.Name = "numericUpDownTurnirniSelekcija";
			this.numericUpDownTurnirniSelekcija.Size = new System.Drawing.Size(72, 20);
			this.numericUpDownTurnirniSelekcija.TabIndex = 16;
			this.numericUpDownTurnirniSelekcija.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.numericUpDownTurnirniSelekcija.Value = new System.Decimal(new int[] {
																						 30,
																						 0,
																						 0,
																						 0});
			// 
			// numericUpDownTurniri
			// 
			this.numericUpDownTurniri.Location = new System.Drawing.Point(192, 152);
			this.numericUpDownTurniri.Maximum = new System.Decimal(new int[] {
																				 7,
																				 0,
																				 0,
																				 0});
			this.numericUpDownTurniri.Minimum = new System.Decimal(new int[] {
																				 3,
																				 0,
																				 0,
																				 0});
			this.numericUpDownTurniri.Name = "numericUpDownTurniri";
			this.numericUpDownTurniri.Size = new System.Drawing.Size(72, 20);
			this.numericUpDownTurniri.TabIndex = 15;
			this.numericUpDownTurniri.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.numericUpDownTurniri.Value = new System.Decimal(new int[] {
																			   3,
																			   0,
																			   0,
																			   0});
			// 
			// textBoxEpsilon
			// 
			this.textBoxEpsilon.Location = new System.Drawing.Point(192, 64);
			this.textBoxEpsilon.Name = "textBoxEpsilon";
			this.textBoxEpsilon.Size = new System.Drawing.Size(72, 20);
			this.textBoxEpsilon.TabIndex = 11;
			this.textBoxEpsilon.Text = "0,00005";
			this.textBoxEpsilon.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// labelTurniriSelekcija
			// 
			this.labelTurniriSelekcija.Location = new System.Drawing.Point(8, 120);
			this.labelTurniriSelekcija.Name = "labelTurniriSelekcija";
			this.labelTurniriSelekcija.Size = new System.Drawing.Size(176, 23);
			this.labelTurniriSelekcija.TabIndex = 9;
			this.labelTurniriSelekcija.Text = "Vjerojatnost Selekcije / Krizanja";
			this.labelTurniriSelekcija.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// labelVelicinaTurnira
			// 
			this.labelVelicinaTurnira.Location = new System.Drawing.Point(8, 152);
			this.labelVelicinaTurnira.Name = "labelVelicinaTurnira";
			this.labelVelicinaTurnira.TabIndex = 8;
			this.labelVelicinaTurnira.Text = "Velicina Turnira";
			this.labelVelicinaTurnira.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// labelEpsilon
			// 
			this.labelEpsilon.Location = new System.Drawing.Point(16, 64);
			this.labelEpsilon.Name = "labelEpsilon";
			this.labelEpsilon.Size = new System.Drawing.Size(72, 23);
			this.labelEpsilon.TabIndex = 7;
			this.labelEpsilon.Text = "Epsilon";
			this.labelEpsilon.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// labelPrirodnaKrizanje
			// 
			this.labelPrirodnaKrizanje.Location = new System.Drawing.Point(16, 32);
			this.labelPrirodnaKrizanje.Name = "labelPrirodnaKrizanje";
			this.labelPrirodnaKrizanje.Size = new System.Drawing.Size(176, 23);
			this.labelPrirodnaKrizanje.TabIndex = 6;
			this.labelPrirodnaKrizanje.Text = "Vjerojatnost Krizanja / Eliminacije";
			this.labelPrirodnaKrizanje.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// radioButtonTurnirskaSelekcija
			// 
			this.radioButtonTurnirskaSelekcija.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.radioButtonTurnirskaSelekcija.Location = new System.Drawing.Point(0, 96);
			this.radioButtonTurnirskaSelekcija.Name = "radioButtonTurnirskaSelekcija";
			this.radioButtonTurnirskaSelekcija.Size = new System.Drawing.Size(120, 24);
			this.radioButtonTurnirskaSelekcija.TabIndex = 5;
			this.radioButtonTurnirskaSelekcija.Text = "Turnirska Selekcija";
			// 
			// radioButtonPrirodnaSelekcija
			// 
			this.radioButtonPrirodnaSelekcija.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.radioButtonPrirodnaSelekcija.Checked = true;
			this.radioButtonPrirodnaSelekcija.Location = new System.Drawing.Point(0, 8);
			this.radioButtonPrirodnaSelekcija.Name = "radioButtonPrirodnaSelekcija";
			this.radioButtonPrirodnaSelekcija.Size = new System.Drawing.Size(120, 24);
			this.radioButtonPrirodnaSelekcija.TabIndex = 4;
			this.radioButtonPrirodnaSelekcija.TabStop = true;
			this.radioButtonPrirodnaSelekcija.Text = "Prirodna Selekcija";
			// 
			// Krizanje
			// 
			this.Krizanje.Controls.Add(this.radioButtonGreedyCrossover);
			this.Krizanje.Controls.Add(this.radioButtonGSX);
			this.Krizanje.Controls.Add(this.radioButtonPMX);
			this.Krizanje.Location = new System.Drawing.Point(4, 22);
			this.Krizanje.Name = "Krizanje";
			this.Krizanje.Size = new System.Drawing.Size(272, 182);
			this.Krizanje.TabIndex = 2;
			this.Krizanje.Text = "Krizanje";
			// 
			// radioButtonGreedyCrossover
			// 
			this.radioButtonGreedyCrossover.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.radioButtonGreedyCrossover.Location = new System.Drawing.Point(64, 80);
			this.radioButtonGreedyCrossover.Name = "radioButtonGreedyCrossover";
			this.radioButtonGreedyCrossover.Size = new System.Drawing.Size(120, 24);
			this.radioButtonGreedyCrossover.TabIndex = 7;
			this.radioButtonGreedyCrossover.Text = "Greedy Crossover";
			// 
			// radioButtonGSX
			// 
			this.radioButtonGSX.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.radioButtonGSX.Checked = true;
			this.radioButtonGSX.Location = new System.Drawing.Point(64, 40);
			this.radioButtonGSX.Name = "radioButtonGSX";
			this.radioButtonGSX.Size = new System.Drawing.Size(120, 24);
			this.radioButtonGSX.TabIndex = 6;
			this.radioButtonGSX.TabStop = true;
			this.radioButtonGSX.Text = "GSX";
			// 
			// radioButtonPMX
			// 
			this.radioButtonPMX.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.radioButtonPMX.Location = new System.Drawing.Point(64, 120);
			this.radioButtonPMX.Name = "radioButtonPMX";
			this.radioButtonPMX.Size = new System.Drawing.Size(120, 24);
			this.radioButtonPMX.TabIndex = 5;
			this.radioButtonPMX.Text = "PMX";
			// 
			// Mutacija
			// 
			this.Mutacija.Controls.Add(this.vjerojatnostMutacijeUpDown);
			this.Mutacija.Controls.Add(this.vjerojatnostMutacijeLabel);
			this.Mutacija.Controls.Add(this.radioButton2opt);
			this.Mutacija.Controls.Add(this.radioButtonJednostavna);
			this.Mutacija.Controls.Add(this.radioButtonGreedySwap);
			this.Mutacija.Location = new System.Drawing.Point(4, 22);
			this.Mutacija.Name = "Mutacija";
			this.Mutacija.Size = new System.Drawing.Size(272, 182);
			this.Mutacija.TabIndex = 3;
			this.Mutacija.Text = "Mutacija";
			// 
			// vjerojatnostMutacijeUpDown
			// 
			this.vjerojatnostMutacijeUpDown.Location = new System.Drawing.Point(192, 136);
			this.vjerojatnostMutacijeUpDown.Name = "vjerojatnostMutacijeUpDown";
			this.vjerojatnostMutacijeUpDown.Size = new System.Drawing.Size(72, 20);
			this.vjerojatnostMutacijeUpDown.TabIndex = 16;
			this.vjerojatnostMutacijeUpDown.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.vjerojatnostMutacijeUpDown.Value = new System.Decimal(new int[] {
																					 10,
																					 0,
																					 0,
																					 0});
			// 
			// vjerojatnostMutacijeLabel
			// 
			this.vjerojatnostMutacijeLabel.Location = new System.Drawing.Point(8, 136);
			this.vjerojatnostMutacijeLabel.Name = "vjerojatnostMutacijeLabel";
			this.vjerojatnostMutacijeLabel.Size = new System.Drawing.Size(120, 23);
			this.vjerojatnostMutacijeLabel.TabIndex = 9;
			this.vjerojatnostMutacijeLabel.Text = "Vjerojatnost Mutacije";
			this.vjerojatnostMutacijeLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// radioButton2opt
			// 
			this.radioButton2opt.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.radioButton2opt.Checked = true;
			this.radioButton2opt.Location = new System.Drawing.Point(40, 88);
			this.radioButton2opt.Name = "radioButton2opt";
			this.radioButton2opt.Size = new System.Drawing.Size(160, 24);
			this.radioButton2opt.TabIndex = 8;
			this.radioButton2opt.TabStop = true;
			this.radioButton2opt.Text = "2opt Metoda";
			// 
			// radioButtonJednostavna
			// 
			this.radioButtonJednostavna.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.radioButtonJednostavna.Location = new System.Drawing.Point(40, 24);
			this.radioButtonJednostavna.Name = "radioButtonJednostavna";
			this.radioButtonJednostavna.Size = new System.Drawing.Size(160, 24);
			this.radioButtonJednostavna.TabIndex = 7;
			this.radioButtonJednostavna.Text = "Jednostavna Mutacija";
			// 
			// radioButtonGreedySwap
			// 
			this.radioButtonGreedySwap.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.radioButtonGreedySwap.Location = new System.Drawing.Point(40, 56);
			this.radioButtonGreedySwap.Name = "radioButtonGreedySwap";
			this.radioButtonGreedySwap.Size = new System.Drawing.Size(160, 24);
			this.radioButtonGreedySwap.TabIndex = 6;
			this.radioButtonGreedySwap.Text = "GreedySwap Mutacija";
			// 
			// buttonOK
			// 
			this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonOK.Location = new System.Drawing.Point(240, 248);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.TabIndex = 1;
			this.buttonOK.Text = "OK";
			this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
			// 
			// buttonDefault
			// 
			this.buttonDefault.Location = new System.Drawing.Point(152, 248);
			this.buttonDefault.Name = "buttonDefault";
			this.buttonDefault.TabIndex = 2;
			this.buttonDefault.Text = "Default";
			this.buttonDefault.Click += new System.EventHandler(this.buttonDefault_Click);
			// 
			// parametriForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(320, 286);
			this.Controls.Add(this.buttonDefault);
			this.Controls.Add(this.buttonOK);
			this.Controls.Add(this.tabControl);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "parametriForm";
			this.Text = "parametri";
			this.tabControl.ResumeLayout(false);
			this.OsnovniParametri.ResumeLayout(false);
			this.Selekcija.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownPrirodna)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownTurnirniSelekcija)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownTurniri)).EndInit();
			this.Krizanje.ResumeLayout(false);
			this.Mutacija.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.vjerojatnostMutacijeUpDown)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
		
		/// <summary>
		/// Postavljanje odabranih parametara
		/// </summary>
		private void buttonOK_Click(object sender, System.EventArgs e)
		{
			this.Parametri.VelPopulacije = System.Convert.ToInt32(this.textBoxVelicinaPopulacije.Text);
			if (this.radioButtonBrojGeneracija.Checked)
			{
				this.Parametri.UvjetZaustavljanja = 0;
				this.Parametri.BrojGeneracija = System.Convert.ToInt32(this.textBoxBrojGeneracija.Text);
			}
			else
			{
				this.Parametri.UvjetZaustavljanja = 1;
				this.Parametri.NepromjenjeniNajbolji = System.Convert.ToInt32(this.textBoxNepromjenjeni.Text);
			}
			this.Parametri.BrisanjeDuplikata = this.checkBoxBrisanjeDuplikata.Checked;
			
			if (this.radioButtonPrirodnaSelekcija.Checked)
			{
				this.Parametri.VrstaSelekcije = 0;
				this.Parametri.VjerojatnostKrizanja = (short)this.numericUpDownPrirodna.Value;
			}
			else
			{
				this.Parametri.VrstaSelekcije = 1;
				this.Parametri.VjerojatnostKrizanja = (short)this.numericUpDownTurnirniSelekcija.Value;
			}
			this.Parametri.Epsilon = System.Convert.ToDouble(this.textBoxEpsilon.Text);
			this.Parametri.VelTurnira = (short)this.numericUpDownTurniri.Value;

			if (this.radioButtonGSX.Checked)
			{
				this.Parametri.VrstaKrizanja = 0;
			}
			else
			{
				if (this.radioButtonGreedyCrossover.Checked)
				{
					this.Parametri.VrstaKrizanja = 1;
				}
				else
				{
					this.Parametri.VrstaKrizanja = 2;
				}
			}
			if (this.radioButtonJednostavna.Checked)
			{
				this.Parametri.VrstaMutacije = 0;
			}
			if (this.radioButtonGreedySwap.Checked)
			{
				this.Parametri.VrstaMutacije = 1;
			}
			if(this.radioButton2opt.Checked)
			{
				this.Parametri.VrstaMutacije = 2;
			}
			this.Parametri.VjerojatnostMutacije = (short) this.vjerojatnostMutacijeUpDown.Value;
		}
		/// <summary>
		/// Postavljanje defaultnih parametara
		/// </summary>
		private void buttonDefault_Click(object sender, System.EventArgs e)
		{
			this.Parametri.Default();
			this.ispisiParametre();
			
		}
		/// <summary>
		/// Ispis trenutnih parametara na ekran
		/// </summary>
		private void ispisiParametre()
		{
			this.textBoxVelicinaPopulacije.Text = this.Parametri.VelPopulacije.ToString();
			switch (this.Parametri.UvjetZaustavljanja)
			{
				case 0:
					this.radioButtonBrojGeneracija.Checked = true;
					break;
				case 1:
					this.radioButtonNepromjenjeni.Checked = true;
					break;
			}
			this.textBoxBrojGeneracija.Text = this.Parametri.BrojGeneracija.ToString();
			this.textBoxNepromjenjeni.Text = this.Parametri.NepromjenjeniNajbolji.ToString();
			this.checkBoxBrisanjeDuplikata.Checked = this.Parametri.BrisanjeDuplikata;
			//selekcija
			switch (this.Parametri.VrstaSelekcije)
			{
				case 0:
					this.radioButtonPrirodnaSelekcija.Checked = true;
					break;
				case 1:
					this.radioButtonTurnirskaSelekcija.Checked = true;
					break;
			}
			this.numericUpDownPrirodna.Value = this.Parametri.VjerojatnostKrizanja;
			this.textBoxEpsilon.Text = this.Parametri.Epsilon.ToString();
			this.numericUpDownTurnirniSelekcija.Value = this.Parametri.VjerojatnostKrizanja;
			this.numericUpDownTurniri.Value = this.Parametri.VelTurnira;

			//krizanje
			switch (this.Parametri.VrstaKrizanja)
			{
				case 0:
					this.radioButtonGSX.Checked = true;
					break;
				case 1:
					this.radioButtonGreedyCrossover.Checked = true;
					break;
				case 2:
					this.radioButtonPMX.Checked = true;
					break;
			}	

			//mutacija
			switch (this.Parametri.VrstaMutacije)
			{
				case 0:
					this.radioButtonJednostavna.Checked = true;
					break;
				case 1:
					this.radioButtonGreedySwap.Checked = true;
					break;
				case 2:
					this.radioButton2opt.Checked = true;
					break;
			}	
			this.vjerojatnostMutacijeUpDown.Value = this.Parametri.VjerojatnostMutacije;
			
		}
		
	}
}
