using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.Threading;

namespace TSP
{
	/// <summary>
	/// Implementacija suelja i tkoa izvoenja genetskog algoritma
	/// </summary>
	public class TSPInterface : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonParametri;
		private System.Windows.Forms.Button buttonStani;

		
		private Algoritam TSPAlg;
		private System.Drawing.Drawing2D.GraphicsPath mousePath;
		private System.Windows.Forms.Button ucitajUdaljenosti;
		private double[][] kord;
		private int brGradova;
		private Parametri parametri;
		private bool crtajStazu = false;
		Kromosom najbolji;
		private Thread pokreniAlgoritam;
	private System.DateTime start;
		private System.DateTime stop;
		private System.TimeSpan interval;
		private ArrayList tocke;
		private System.Windows.Forms.Button buttonStart;
		private System.Windows.Forms.Panel CrtacaPloca;
		private System.Windows.Forms.Button buttonReset;
		private System.Windows.Forms.Label labelGen;
		private System.Windows.Forms.Label labelVrijeme;
		private System.ComponentModel.IContainer components = null;

		public TSPInterface()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			mousePath = new System.Drawing.Drawing2D.GraphicsPath();
			parametri = new Parametri();
			this.tocke = new ArrayList();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonStart = new System.Windows.Forms.Button();
			this.buttonParametri = new System.Windows.Forms.Button();
			this.buttonStani = new System.Windows.Forms.Button();
			this.ucitajUdaljenosti = new System.Windows.Forms.Button();
			this.buttonReset = new System.Windows.Forms.Button();
			this.CrtacaPloca = new System.Windows.Forms.Panel();
			this.labelGen = new System.Windows.Forms.Label();
			this.labelVrijeme = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// buttonStart
			// 
			this.buttonStart.BackColor = System.Drawing.Color.Cornsilk;
			this.buttonStart.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonStart.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.buttonStart.ForeColor = System.Drawing.Color.DodgerBlue;
			this.buttonStart.Location = new System.Drawing.Point(16, 128);
			this.buttonStart.Name = "buttonStart";
			this.buttonStart.Size = new System.Drawing.Size(104, 32);
			this.buttonStart.TabIndex = 2;
			this.buttonStart.Text = "S T A R T";
			this.buttonStart.Visible = false;
			this.buttonStart.Click += new System.EventHandler(this.buttonStart_Click);
			// 
			// buttonParametri
			// 
			this.buttonParametri.BackColor = System.Drawing.Color.Cornsilk;
			this.buttonParametri.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonParametri.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.buttonParametri.ForeColor = System.Drawing.Color.Red;
			this.buttonParametri.Location = new System.Drawing.Point(16, 72);
			this.buttonParametri.Name = "buttonParametri";
			this.buttonParametri.Size = new System.Drawing.Size(104, 40);
			this.buttonParametri.TabIndex = 3;
			this.buttonParametri.Text = "Postavi Parametre";
			this.buttonParametri.Visible = false;
			this.buttonParametri.Click += new System.EventHandler(this.buttonParametri_Click);
			// 
			// buttonStani
			// 
			this.buttonStani.BackColor = System.Drawing.Color.Cornsilk;
			this.buttonStani.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonStani.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.buttonStani.ForeColor = System.Drawing.Color.Red;
			this.buttonStani.Location = new System.Drawing.Point(16, 264);
			this.buttonStani.Name = "buttonStani";
			this.buttonStani.Size = new System.Drawing.Size(104, 32);
			this.buttonStani.TabIndex = 4;
			this.buttonStani.Text = "S T O P";
			this.buttonStani.Visible = false;
			this.buttonStani.Click += new System.EventHandler(this.buttonStani_Click);
			// 
			// ucitajUdaljenosti
			// 
			this.ucitajUdaljenosti.BackColor = System.Drawing.Color.Cornsilk;
			this.ucitajUdaljenosti.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.ucitajUdaljenosti.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.ucitajUdaljenosti.ForeColor = System.Drawing.Color.Red;
			this.ucitajUdaljenosti.Location = new System.Drawing.Point(16, 16);
			this.ucitajUdaljenosti.Name = "ucitajUdaljenosti";
			this.ucitajUdaljenosti.Size = new System.Drawing.Size(104, 40);
			this.ucitajUdaljenosti.TabIndex = 5;
			this.ucitajUdaljenosti.Text = "Ucitaj Udaljenosti";
			this.ucitajUdaljenosti.Click += new System.EventHandler(this.ucitajUdaljenosti_Click);
			// 
			// buttonReset
			// 
			this.buttonReset.BackColor = System.Drawing.Color.Cornsilk;
			this.buttonReset.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonReset.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.buttonReset.ForeColor = System.Drawing.Color.Red;
			this.buttonReset.Location = new System.Drawing.Point(624, 560);
			this.buttonReset.Name = "buttonReset";
			this.buttonReset.Size = new System.Drawing.Size(104, 32);
			this.buttonReset.TabIndex = 6;
			this.buttonReset.Text = "RESET";
			this.buttonReset.Click += new System.EventHandler(this.buttonReset_Click);
			// 
			// CrtacaPloca
			// 
			this.CrtacaPloca.BackColor = System.Drawing.Color.Silver;
			this.CrtacaPloca.Location = new System.Drawing.Point(144, 16);
			this.CrtacaPloca.Name = "CrtacaPloca";
			this.CrtacaPloca.Size = new System.Drawing.Size(592, 528);
			this.CrtacaPloca.TabIndex = 1;
			this.CrtacaPloca.MouseUp += new System.Windows.Forms.MouseEventHandler(this.CrtacaPloca_MouseUp);
			this.CrtacaPloca.Paint += new System.Windows.Forms.PaintEventHandler(this.CrtacaPloca_Paint);
			// 
			// labelGen
			// 
			this.labelGen.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.labelGen.Location = new System.Drawing.Point(16, 552);
			this.labelGen.Name = "labelGen";
			this.labelGen.Size = new System.Drawing.Size(600, 40);
			this.labelGen.TabIndex = 12;
			this.labelGen.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.labelGen.Visible = false;
			// 
			// labelVrijeme
			// 
			this.labelVrijeme.Location = new System.Drawing.Point(16, 600);
			this.labelVrijeme.Name = "labelVrijeme";
			this.labelVrijeme.Size = new System.Drawing.Size(336, 23);
			this.labelVrijeme.TabIndex = 18;
			this.labelVrijeme.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// TSPInterface
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.WhiteSmoke;
			this.ClientSize = new System.Drawing.Size(754, 632);
			this.Controls.Add(this.labelVrijeme);
			this.Controls.Add(this.labelGen);
			this.Controls.Add(this.buttonReset);
			this.Controls.Add(this.ucitajUdaljenosti);
			this.Controls.Add(this.CrtacaPloca);
			this.Controls.Add(this.buttonParametri);
			this.Controls.Add(this.buttonStart);
			this.Controls.Add(this.buttonStani);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "TSPInterface";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "TSP";
			this.Closed += new System.EventHandler(this.TSPInterface_Closed);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new TSPInterface());
		}

		private void buttonStart_Click(object sender, System.EventArgs e)
		{
			this.labelGen.Text = "";
			this.labelVrijeme.Text = "";
			this.crtajStazu = false;
			//stvaranje nove dretve koja e izvoditi algoritam
			this.pokreniAlgoritam = new Thread(new ThreadStart(algoritamStart));
			this.pokreniAlgoritam.IsBackground = true;
			this.pokreniAlgoritam.Priority = System.Threading.ThreadPriority.Lowest;
			this.pokreniAlgoritam.Name = "TSP Algoritam";
			//pokretanje dretve
			this.pokreniAlgoritam.Start();
			this.buttonStani.Visible = true;
			this.buttonStart.Enabled = false;
			this.buttonReset.Enabled = false;
			this.Refresh();
		}

		private void algoritamStart ()
		{
			//uzimanje vremena za brojac
			start = System.DateTime.Now;
			int brojac = 0;
			Random rnd = new Random();
			int t1,t2,R;
			labelGen.Text = "";
			this.labelVrijeme.Text = "";
			switch (this.parametri.VrstaSelekcije)
			{	
				//slucaj prirodne selekcije
				case 0:
					this.TSPAlg = new Algoritam(this.parametri.VelPopulacije,this.brGradova,
						this.parametri.VjerojatnostKrizanja,this.parametri.Epsilon,
						this.kord);

					najbolji = this.TSPAlg.nadjiNajboljeg();
					this.crtajStazu = true;
					this.CrtacaPloca.Invalidate();
					this.crtajStazu = false;

					//izracunavanje tocaka prekida za slucaj PMX krizanja
					t1 = rnd.Next(1,this.brGradova);
					
					do
					{
						t2 = rnd.Next(1,this.brGradova);
					}while(t1 <= t2);

					//petlja algoritma
					do
					{	
						//ispis trenutnog statusa
						this.labelGen.Text = "Generacija/Nepromjenjeni: "+brojac.ToString()+", " +"Najkraca staza: "+najbolji.DuljinaPuta.ToString();
						if (this.crtajStazu)
						{
							this.CrtacaPloca.Invalidate();
						}					
						this.crtajStazu = false;
						this.TSPAlg.PrirodnaSelekcija();
						R =  this.parametri.VelPopulacije * this.parametri.VjerojatnostKrizanja / 100;
						TSPAlg.Populacija.Clear();
						
						
						//obavi krizanja i stavi djecu u TSPAlg.Populacija
						for(int i=0;i < R;i++)
						{
							int rod1 = rnd.Next(this.parametri.VelPopulacije - R);
							int rod2;
							do
							{
								rod2 = rnd.Next(this.parametri.VelPopulacije - R);
							}while(rod1 == rod2);
							
							Kromosom dijete = this.krizaj((Kromosom)TSPAlg.SortPop[rod1],(Kromosom)TSPAlg.SortPop[rod2],this.parametri.VrstaKrizanja,t1,t2);
							TSPAlg.Populacija.Add(dijete);
						}
						//radi mutaciju
						R =  this.TSPAlg.Populacija.Count * this.parametri.VjerojatnostMutacije / 100;
						for (int i = 0;i < R;i++)
						{
							ArrayList vecMutirani = new ArrayList();
							int sluc;
							do
							{
								sluc = rnd.Next(this.TSPAlg.Populacija.Count);
							}
							while(vecMutirani.IndexOf(sluc) != -1);
				
							vecMutirani.Add(sluc);
							this.TSPAlg.Populacija[sluc] = this.mutiraj((Kromosom)this.TSPAlg.Populacija[sluc],this.parametri.VrstaMutacije);
						}
						foreach (object o in this.TSPAlg.SortPop)
							this.TSPAlg.Populacija.Add(o);

						//pronadji najboljeg
						Kromosom tmp = this.TSPAlg.nadjiNajboljeg();
						if(najbolji.DuljinaPuta > tmp.DuljinaPuta)
						{
							najbolji.DuljinaPuta = tmp.DuljinaPuta;
							najbolji.Chromosome.Clear();
							foreach(object o in tmp.Chromosome)
								najbolji.Chromosome.Add(o);
							this.crtajStazu = true;
						}
						//provjeri da li se treba zaustaviti s algoritmom
						if((this.parametri.UvjetZaustavljanja == 0) && (this.parametri.BrojGeneracija == brojac))
						{
							break;
						}
						
						if((this.parametri.UvjetZaustavljanja == 1))
						{
							if(this.parametri.NepromjenjeniNajbolji == brojac)
							{
								break;
							}
							if (this.crtajStazu == true)
								brojac = 0;
						}
												
						brojac++;
						this.TSPAlg.SortPop.Clear();
					}while(true);
					this.crtajStazu = false;
					break;
				//slucaj turnirske selekcije
				case 1:
					TSPAlg = new Algoritam(this.parametri.VelPopulacije,this.brGradova,this.kord);
					najbolji = this.TSPAlg.nadjiNajboljeg();
					this.crtajStazu = true;
					this.CrtacaPloca.Invalidate();
					this.crtajStazu = false;
					//izracunavanje tocaka prekida za slucaj PMX krizanja
					t1 = rnd.Next(1,this.brGradova);
					
					do
					{
						t2 = rnd.Next(1,this.brGradova);
					}while(t1 <= t2);
					
					//petlja algoritma
					do
					{		
						//ispis statusa
							this.labelGen.Text = "Generacija/Nepromjenjeni: "+brojac.ToString()+", " +"Najkraca staza: "+najbolji.DuljinaPuta.ToString();
							if (this.crtajStazu)
							{
								this.CrtacaPloca.Invalidate();
							}					
						this.crtajStazu = false;				
						ArrayList odabrani = new ArrayList();
						//generiranje indexa djece kaj e biti mutirana	
						ArrayList zaMutirati = new ArrayList();

						 R = System.Convert.ToInt32( this.parametri.VelPopulacije * this.parametri.VjerojatnostKrizanja / 100);
						for (int j = 0;j < R * this.parametri.VjerojatnostMutacije / 100; j++)
						{
							zaMutirati.Add(rnd.Next(R));
						}
						//radjenje turnirske selekcije
						for(int j = 0;j < R;j++)
						{
							
							Kromosom najlosiji = this.TSPAlg.nadjiNajboljeg();
				
							for(int i = 0; i < this.parametri.VelTurnira;i++)
							{
								int broj = rnd.Next(this.parametri.VelPopulacije);
								if (odabrani.Contains(this.TSPAlg.Populacija[broj]))
								{
									i--;
									continue;
								}
								odabrani.Add(this.TSPAlg.Populacija[broj]);
								//ostaviti ili ne ovaj vece ili jednako!!!!!!!!!!!!!!!!!!!!!
								if (((Kromosom)odabrani[i]).DuljinaPuta > najlosiji.DuljinaPuta)
									najlosiji = (Kromosom)odabrani[i];
							}
							odabrani.Remove(najlosiji);
					
							this.TSPAlg.Populacija.Remove(najlosiji);
							int rod1 = rnd.Next(odabrani.Count);
							int rod2;
							do
							{
								rod2 = rnd.Next(odabrani.Count);
							}while(rod1 == rod2);
						
							//napravi krizanje
							najlosiji = this.krizaj((Kromosom)odabrani[rod1],(Kromosom)odabrani[rod2],this.parametri.VrstaKrizanja,t1,t2);
							//brojevi koji su mut % broja djece i ta djeca mutiraju
							if (zaMutirati.Contains(j))
							{
								this.TSPAlg.Populacija.Add(this.mutiraj(najlosiji,this.parametri.VrstaMutacije));
							}
							else
								this.TSPAlg.Populacija.Add(najlosiji);

							odabrani.Clear();
						}
						//nadji najboljeg
						Kromosom tmp = this.TSPAlg.nadjiNajboljeg();
						if(najbolji.DuljinaPuta > tmp.DuljinaPuta)
						{
							najbolji.DuljinaPuta = tmp.DuljinaPuta;
							najbolji.Chromosome.Clear();
							foreach(object o in tmp.Chromosome)
								najbolji.Chromosome.Add(o);
							this.crtajStazu = true;
						}
						//provjeri da li se treba zaustaviti s algoritmom
						if((this.parametri.UvjetZaustavljanja == 0) && (this.parametri.BrojGeneracija == brojac))
						{
							break;
						}
						
						if((this.parametri.UvjetZaustavljanja == 1))
						{
							if(this.parametri.NepromjenjeniNajbolji == brojac)
							{
								break;
							}
							if (this.crtajStazu == true)
								brojac = 0;
						}
												
						brojac++;
					}while(true);
					this.crtajStazu = false;
					break;
			}
			//postavljanje sucelja nakon izvodjenja programa
			this.labelGen.Text = najbolji.ToString();
			stop = System.DateTime.Now;
			interval = stop - start;
			labelVrijeme.Text ="Vrijeme izvoenja: "+interval.ToString();
			this.buttonStani.Visible = false;
			this.buttonStart.Enabled = true;
			this.buttonParametri.Enabled = true;
			this.buttonReset.Enabled = true;
			this.crtajStazu = true;
		}

		//ova metoda sluzi za prisilno zaustavljanje algoritma, sve se vraa na dio prije ucitaj parametre.
		private void buttonStani_Click(object sender, System.EventArgs e)
		{
			this.crtajStazu = true;	
			this.pokreniAlgoritam.Abort();
			this.labelGen.Text = najbolji.ToString();
			stop = System.DateTime.Now;
			interval = stop - start;
			labelVrijeme.Text ="Vrijeme izvoenja: "+interval.ToString();
			this.TSPAlg.SortPop.Clear();
			this.TSPAlg.Populacija.Clear();
			
			this.buttonParametri.Enabled = true;
			this.buttonStart.Enabled = true;
			this.buttonReset.Enabled = true;
			this.buttonStani.Visible = false;
		}

		private void CrtacaPloca_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			//crtanje po ploci
			Brush br = new SolidBrush(Color.Tomato);
			e.Graphics.FillPath(br,mousePath);
			if (this.crtajStazu == true)
			{
				Pen blue = new Pen(Color.DarkBlue,2);
				for (int i = 0; i < this.brGradova;i++)
				{
					e.Graphics.DrawLine(blue,mousePath.PathPoints[((int)(najbolji.Chromosome[i])) * 4],mousePath.PathPoints[((int)(najbolji.Chromosome[(i+1) % this.brGradova])) * 4]);
				}
			}
		}
		
		private void CrtacaPloca_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			//uzimanje tocaka sa ploce
			Point t = new Point(e.X,e.Y);
			tocke.Add(t);
			Rectangle prav = new Rectangle(e.X,e.Y,5,5);
			mousePath.AddRectangle(prav);
			CrtacaPloca.Invalidate();
		}

		//ucitavanje udaljenosti
		private void ucitajUdaljenosti_Click(object sender, System.EventArgs e)
		{
			string fileName;
			if (mousePath.PointCount < 5)
			{

				this.CrtacaPloca.Enabled = false;
				this.labelGen.Visible = true;
				//otvaranje datoteke
				OpenFileDialog dlg = new OpenFileDialog();
				if (dlg.ShowDialog(this) == DialogResult.OK)
				{
					fileName = dlg.FileName;
					gradovi doc;
					try
					{
						doc = new gradovi(fileName);
					}
					catch(Exception ex)
					{
						MessageBox.Show(this,ex.Message);
						return;
					}
					
					//uzimanje broja gradova
					brGradova = System.Int32.Parse(doc.GetValue("info","brojGradova"));
					
					string[] str = doc.GetValue("tocke","t0").Split(' ');
					PointF t = new PointF((float)System.Double.Parse(str[0]),(float)System.Double.Parse(str[1]));
					tocke.Add(t);
					PointF min = new PointF(t.X,t.Y);
					PointF max = new PointF(t.X,t.Y);
					//vadjenje koordinata i odredjivanje min i max vrijednosti
					for (int i = 1; i < this.brGradova;i++)
					{
						str = doc.GetValue("tocke","t"+i.ToString()).Split(' ');
						t.X =(float)System.Double.Parse(str[0]);
						t.Y =(float)System.Double.Parse(str[1]);
						tocke.Add(t);
						if (min.X > t.X)
							min.X = t.X;
						if (min.Y > t.Y)
							min.Y = t.Y;
						if (max.X < t.X)
							max.X = t.X;
						if (max.Y < t.Y)
							max.Y = t.Y;
					}
					//stvaranje matrice udaljenosti
					kord = new double[brGradova][];
					for (int i = 0; i < brGradova;i++)
						kord[i] = new double[brGradova];
			
					for(int i = 0; i < brGradova-1;i++)
					{
						PointF gradI = (PointF) tocke[i];
						for(int j=i+1; j< brGradova;j++)
						{
							PointF gradJ = (PointF) tocke[j];
					
							double udaljenost = Math.Sqrt(Math.Pow(gradI.X-gradJ.X,2)+Math.Pow(gradI.Y-gradJ.Y,2));
							kord[i][j] = udaljenost;
							kord[j][i] = udaljenost;
						}
						kord[i][i] = 0;
					}
//					if (min.X < 0)
//					{
						for(int i = 0;i<tocke.Count;i++)
						{
							t.X = ((PointF)tocke[i]).X - min.X;
							t.Y = ((PointF)tocke[i]).Y;
							
							tocke.Remove(tocke[i]);
							tocke.Insert(i,t);
						}
//					}

//					if (min.Y < 0)
//					{
						for(int i = 0;i<tocke.Count;i++)
						{
							t.X = ((PointF)tocke[i]).X;
							t.Y = ((PointF)tocke[i]).Y - min.Y;
							
							tocke.Remove(tocke[i]);
							tocke.Insert(i,t);
						}
//					}
					float sX = max.X - min.X;
					float sY = max.Y - min.Y;
					//ucitavanje tocaka kako bi se mogle nacrtati (skaliranje)
					foreach (PointF p in tocke)
					{
						Rectangle prav = new Rectangle((int)(5 + this.CrtacaPloca.Size.Width * 0.97* p.X / sX),(int)(5 + this.CrtacaPloca.Size.Height * 0.97* p.Y / sY),5,5);
						mousePath.AddRectangle(prav);
						CrtacaPloca.Invalidate();	
					}

					this.buttonParametri.Visible = true;
					this.ucitajUdaljenosti.Enabled = false;
				}
			} 
			else
			{
				//ucitavanje za slucaj crtanja po ploci
				this.CrtacaPloca.Enabled = false;
				this.labelGen.Visible = true;
				brGradova = mousePath.PointCount / 4;
				//generiranje matrice udaljenosti
				kord = new double[brGradova][];
				for (int i = 0; i < brGradova;i++)
					kord[i] = new double[brGradova];
			
				for(int i = 0; i < brGradova-1;i++)
				{
					Point gradI = (Point) tocke[i];
					for(int j=i+1; j< brGradova;j++)
					{
						Point gradJ = (Point) tocke[j];
					
						double udaljenost = Math.Sqrt(Math.Pow(gradI.X-gradJ.X,2)+Math.Pow(gradI.Y-gradJ.Y,2));
						kord[i][j] = udaljenost;
						kord[j][i] = udaljenost;
					}
					kord[i][i] = 0;
				}
				this.buttonParametri.Visible = true;
				this.ucitajUdaljenosti.Enabled = false;
			}			
		}
		//namjestanje parametara
		private void buttonParametri_Click(object sender, System.EventArgs e)
		{
			parametriForm dlg = new parametriForm(this.parametri);
			if (dlg.ShowDialog() == DialogResult.OK)
			{
				this.parametri.VelPopulacije = dlg.Parametri.VelPopulacije;
				this.parametri.UvjetZaustavljanja = dlg.Parametri.UvjetZaustavljanja;
				this.parametri.BrojGeneracija = dlg.Parametri.BrojGeneracija;
				this.parametri.NepromjenjeniNajbolji = dlg.Parametri.NepromjenjeniNajbolji;
				this.parametri.BrisanjeDuplikata = dlg.Parametri.BrisanjeDuplikata;
				this.parametri.VrstaSelekcije = dlg.Parametri.VrstaSelekcije;
				this.parametri.VjerojatnostKrizanja = dlg.Parametri.VjerojatnostKrizanja;
				this.parametri.Epsilon = dlg.Parametri.Epsilon;
				this.parametri.VelTurnira = dlg.Parametri.VelTurnira;
				this.parametri.VrstaKrizanja = dlg.Parametri.VrstaKrizanja;
				this.parametri.VrstaMutacije = dlg.Parametri.VrstaMutacije;
				this.parametri.VjerojatnostMutacije = dlg.Parametri.VjerojatnostMutacije;
		
				this.buttonStart.Visible = true;
				this.buttonParametri.Enabled = false;
			}
		}
		//resetiranje svega na pocetnu vrijednost
		private void buttonReset_Click(object sender, System.EventArgs e)
		{
			this.ucitajUdaljenosti.Enabled = true;
			this.buttonStart.Visible = false;
			this.buttonStart.Enabled = true;
			this.buttonParametri.Visible = false;
			this.buttonParametri.Enabled = true;
			this.buttonStani.Visible = false;
			
			this.mousePath.Reset();	
			this.CrtacaPloca.Invalidate();
			this.crtajStazu = false;
			this.CrtacaPloca.Enabled = true;

			this.labelGen.Text = "";
			this.labelGen.Visible = false;
			this.labelVrijeme.Text = "";
			tocke.Clear();
			
		}
		//ubijanje svih zauzetih resurse
		private void TSPInterface_Closed(object sender, System.EventArgs e)
		{
			this.Dispose();
		}
		//krizanje s odabranom vrstom krizanja
		private Kromosom krizaj (Kromosom rod1, Kromosom rod2, short tipKrizanja,int t1,int t2)
		{
			switch(tipKrizanja)
			{
				case 0:
					return TSPAlg.GreedySubtourCrossover(rod1,rod2);
				case 1:
					return TSPAlg.GreedyCrossover(rod1,rod2);
			}
			return TSPAlg.PartiallyMatchedCrossover(rod1,rod2,t1,t2);
			
		}
		//mutacija s odabranom vrstom mutacije
		private Kromosom mutiraj (Kromosom dijete, short tipMutacije)
		{
			switch(tipMutacije)
			{
				case 0:
					return TSPAlg.JednostavnaMutacija(dijete);
				case 1:
					return TSPAlg.GreedySwapMutacija(dijete);
			}
			return TSPAlg._2opt(dijete);
			
		}
	}
}
